package program5.quicksortTurkey;

import arrayTools.CharArrayTool;
import arrayTools.CompareCharInterface;
import arrayTools.CompareIntInterface;
import arrayTools.CompareStringInterface;
import arrayTools.IntArrayTool;
import arrayTools.SwapCharInterface;
import arrayTools.SwapIntInterface;
import arrayTools.SwapString;
import arrayTools.SwapStringInterface;
import quicksort.StringQuicksortInterface;

public class TurkeyQuicksort implements StringQuicksortInterface {

	@Override
	public void quicksort(int[] array, int erstes, int letztes,
			CompareIntInterface intCMP) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
		
			SwapIntInterface swapper=new IntArrayTool();
			swapper.swap(erstes, findBeginning(array, erstes, letztes, intCMP), array);	/*whlt als
			 					Vergleichselement:
			 					*das mittlere Element des Teilarrays fr Anzahl<8
			 					*den Median aus 3 Elementen des Teilarray fr Anzahl<41
			 					*den Pseudomedian aus 9 Elementen des Teilarrays fr Anzahl>40
			 					und legt das Vergleichselement an die erste Position des Teilrrays*/

			int i=erstes+1;
			int j=letztes;
			while(i<=j)
			{
				for(; 0>intCMP.compare(i, erstes, array);i++);	/*sucht von links ein greres 
																oder gleiches Element*/
				
				for(; 0<intCMP.compare(j, erstes, array);j--);	/*sucht von rechts ein kleineres
																oder gleiches Element*/
				
				if(j<i)		/*bricht ab, sobald der Iterator von links und der Iterator von rechts
 							sich kreuzen (Abbruchbedingung)*/
					break;
				
				swapper.swap(i, j, array);	/*tauscht das ger-gleiche und das kleiner-gleiche
											Element*/				
			}
			
			swapper.swap(erstes, j, array);	/*tauscht das Vergleichselement mit dem letzten
											kleiner-gleichen Element*/
			
			quicksort(array, erstes, j-1, intCMP);	/*auf dem Teilarray kleiner-gleich dem
													Vergleichselement*/
			
			quicksort(array, j+1, letztes, intCMP);	/*auf dem Teilarray grer-gleich dem
													Vergleichselement*/
			
		}

	}

	public static int findBeginning(int[] array, int erstes, int letztes,
			CompareIntInterface comparer) {
		// TODO Auto-generated method stub
		
		int number=letztes-erstes+1;
		int mIndex=(letztes+erstes+1)/2;
		
		if(number>7)
		{
			int indexE=erstes;
			int indexL=letztes;
			if(number>40)
			{
				int s=number/8;
				indexE=median(array, indexE, indexE+s, indexE+2*s, comparer);
				mIndex=median(array, mIndex-s, mIndex, mIndex+s, comparer);
				indexE=median(array, indexL-2*s, indexL-s, indexL, comparer);
			}
			mIndex=median(array, indexE, mIndex, indexL, comparer);
		}
		return mIndex;


	}

	public static int median(int[] array, int index1, int index2, int index3,
			CompareIntInterface cmp) {
		// TODO Auto-generated method stub
		
		int int1=array[index1];
		int int2=array[index2];
		int int3=array[index3];
		
		return cmp.compare(int1, int2)<0 ?
				(cmp.compare(int2, int3)<0 ? index2 : cmp.compare(int1, int3)<0? index3 : index1)
				: (cmp.compare(int2, int3)>0 ? index2 : cmp.compare(int1, int3)>0? index3 : index1);
	}

	@Override
	public void quicksort(char[] array, int erstes, int letztes,
			CompareCharInterface charCMP) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
		
			SwapCharInterface swapper=new CharArrayTool();
			swapper.swap(erstes, findBeginning(array, erstes, letztes, charCMP), array);

			int i=erstes+1;
			int j=letztes;
			while(i<=j)
			{
				for(; 0>charCMP.compare(i, erstes, array);i++);
				for(; 0<charCMP.compare(j, erstes, array);j--);
				if(j<i)
					break;
				
				swapper.swap(i, j, array);				
			}
			
			quicksort(array, erstes, j-1, charCMP);
			quicksort(array, j+1, letztes, charCMP);
			
		}

	}
	
	public static int findBeginning(char[] array, int erstes, int letztes,
			CompareCharInterface comparer) {
		// TODO Auto-generated method stub
		
		int number=letztes-erstes+1;
		int mIndex=(letztes+erstes+1)/2;
		
		if(number>7)
		{
			int indexE=erstes;
			int indexL=letztes;
			if(number>40)
			{
				int s=number/8;
				indexE=median(array, indexE, indexE+s, indexE+2*s, comparer);
				mIndex=median(array, mIndex-s, mIndex, mIndex+s, comparer);
				indexE=median(array, indexL-2*s, indexL-s, indexL, comparer);
			}
			mIndex=median(array, indexE, mIndex, indexL, comparer);
		}
		return mIndex;
	}

	public static int median(char[] array, int index1, int index2, int index3,
			CompareCharInterface comparer) {
		// TODO Auto-generated method stub
		
		char c1=array[index1];
		char c2=array[index2];
		char c3=array[index3];
		
		return comparer.compare(c1, c2)<0 ?
				(comparer.compare(c2, c3)<0 ? index2 : comparer.compare(c1, c3)<0? index3 : index1)
				: (comparer.compare(c2, c3)>0 ? index2 : comparer.compare(c1, c3)>0? index3 : index1);
	}

	@Override
	public void quicksort(String[] array, int erstes, int letztes,
			CompareStringInterface stringCMP) {
		// TODO Auto-generated method stub
		if(letztes-erstes>0)
		{
		
			SwapStringInterface swapper=new SwapString();
			swapper.swap(erstes, findBeginning(array, erstes, letztes, stringCMP), array);
	
			int i=erstes+1;
			int j=letztes;
			while(i<=j)
			{
				for(; 0>stringCMP.compare(i, erstes, array);i++);
				for(; 0<stringCMP.compare(j, erstes, array);j--);
				if(j<i)
					break;
				
				swapper.swap(i, j, array);				
			}
			
			quicksort(array, erstes, j-1, stringCMP);
			quicksort(array, j+1, letztes, stringCMP);
			
		}
	}

	public static int findBeginning(String[] array, int erstes, int letztes, CompareStringInterface comparer)
	{
		int number=letztes-erstes+1;
		int mIndex=(letztes+erstes+1)/2;
		
		if(number>7)
		{
			int indexE=erstes;
			int indexL=letztes;
			if(number>40)
			{
				int s=number/8;
				indexE=median(array, indexE, indexE+s, indexE+2*s, comparer);
				mIndex=median(array, mIndex-s, mIndex, mIndex+s, comparer);
				indexE=median(array, indexL-2*s, indexL-s, indexL, comparer);
			}
			mIndex=median(array, indexE, mIndex, indexL, comparer);
		}
		return mIndex;
	}

	public static int median(String[] array, int index1, int index2, int index3, arrayTools.CompareStringInterface cmp)
	{
		String str1=array[index1];
		String str2=array[index2];
		String str3=array[index3];
		
		return cmp.compare(str1, str2)<0 ?
				(cmp.compare(str2, str3)<0 ? index2 : cmp.compare(str1, str3)<0? index3 : index1)
				: (cmp.compare(str2, str3)>0 ? index2 : cmp.compare(str1, str3)>0? index3 : index1);
	}
}
