package program6.partitionQuicksortWegner;

import arrayTools.CharArrayTool;
import arrayTools.CompareCharInterface;
import arrayTools.CompareIntInterface;
import arrayTools.IntArrayTool;
import arrayTools.SwapCharInterface;
import arrayTools.SwapIntInterface;
import quicksort.IntQuicksortInterface;

public class WegnerQuicksort implements IntQuicksortInterface {

	@Override
	public void quicksort(int[] array, int erstes, int letztes,
			CompareIntInterface comparer) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
			SwapIntInterface swapper=new IntArrayTool();
			int iterL=erstes+(int)(java.lang.Math.random()*1000000)%(letztes-erstes+1);	/*whlt ein
											zuflliges Element im Teilarray als Vergleichselement*/
			
			swapper.swap(iterL, erstes, array);	/*das Vergleichselement wird in der ersten Position
												des Arrays abgelegt*/
			
			int putL=iterL=erstes+1;
			int iterR=letztes;
			int putR=letztes;
			while(iterL<=iterR)
			{
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von links ein greres Element*/
					if(0==comparer.compare(iterL, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putL++, iterL, array);			/*den linken Rand geschoben*/
					iterL++;
				}
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von rechts ein greres Element*/
					if(0==comparer.compare(iterR, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putR--, iterL, array);			/*den rechten Rand geschoben*/
					iterR--;
				}
				
				if(iterL>iterR)	/*bricht ab, sobald der Iterator von links und der Iterator von 
								rechts sich kreuzen (Abbruchbedingung)*/
					break;
				
				swapper.swap(iterL, iterR, array);	/*tauscht das gerhe und das kleinere
													Element*/			
			}
			//AB HIER DETAILLIERT ERKLREN!!!!!!!!!!!!!
			int anz=Math.min(putL, iterL-putL); /*berechnet die Anzahl der gleichen Elemente am
			 									linken Rand, die verschoben werden mssen*/
			
			for(int i=erstes, h=iterL-anz; anz>0 ;anz--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			anz=Math.min(putR, iterR);	/*berechnet die Anzahl der gleichen Elemente am
										rechten Rand, die verschoben werden mssen*/
			
			for(int i=iterR, h=letztes+1-anz;anz>0;anz--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			quicksort(array, erstes, erstes+iterL-putL, comparer);	/*auf dem Teilarray kleiner dem
																	Vergleichselement*/
			
			quicksort(array, letztes-putR+iterR, letztes, comparer);/*auf dem Teilarray grer dem
																	Vergleichselement*/
			
		}

	}

	@Override
	public void quicksort(char[] array, int erstes, int letztes,
			CompareCharInterface comparer) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
			SwapCharInterface swapper=new CharArrayTool();
			int iterL=erstes+(int)(java.lang.Math.random()*1000000)%(letztes-erstes+1);	/*whlt ein
											zuflliges Element im Teilarray als Vergleichselement*/
			
			swapper.swap(iterL, erstes, array);	/*das Vergleichselement wird in der ersten Position
												des Arrays abgelegt*/
			
			int putL=iterL=erstes+1;
			int iterR=letztes;
			int putR=letztes;
			while(iterL<=iterR)
			{
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von links ein greres Element*/
					if(0==comparer.compare(iterL, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putL++, iterL, array);			/*den linken Rand geschoben*/
					iterL++;
				}
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von rechts ein greres Element*/
					if(0==comparer.compare(iterR, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putR--, iterL, array);			/*den rechten Rand geschoben*/
					iterR--;
				}
				
				if(iterL>iterR)	/*bricht ab, sobald der Iterator von links und der Iterator von 
								rechts sich kreuzen (Abbruchbedingung)*/
					break;
				
				swapper.swap(iterL, iterR, array);	/*tauscht das gerhe und das kleinere
													Element*/		
			}
			
			int anz=Math.min(putL, iterL-putL); /*berechnet die Anzahl der gleichen Elemente am
				linken Rand, die verschoben werden mssen*/

			for(int i=erstes, h=iterL-anz; anz>0 ;anz--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/

			anz=Math.min(putR, iterR);	/*berechnet die Anzahl der gleichen Elemente am
										rechten Rand, die verschoben werden mssen*/

			for(int i=iterR, h=letztes+1-anz;anz>0;anz--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/

			quicksort(array, erstes, erstes+iterL-putL, comparer);	/*auf dem Teilarray kleiner dem
																	Vergleichselement*/

			quicksort(array, letztes-putR+iterR, letztes, comparer);/*auf dem Teilarray grer dem
																	Vergleichselement*/
		}
	}

}
