package program7.readypartitionQuicksortWegner;

import arrayTools.CharArrayTool;
import arrayTools.CompareCharInterface;
import arrayTools.CompareIntInterface;
import arrayTools.CompareStringInterface;
import arrayTools.IntArrayTool;
import arrayTools.SwapCharInterface;
import arrayTools.SwapIntInterface;
import arrayTools.SwapString;
import arrayTools.SwapStringInterface;
import quicksort.CharQuicksortInterface;
import quicksort.IntQuicksortInterface;
import quicksort.StringQuicksortInterface;
import program5.quicksortTurkey.TurkeyQuicksort;

public class ReadyWegnerQuicksort implements CharQuicksortInterface,
		IntQuicksortInterface, StringQuicksortInterface {

	@Override
	public void quicksort(char[] array, int erstes, int letztes,
			CompareCharInterface comparer) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
			SwapCharInterface swapper=new CharArrayTool();
			swapper.swap(erstes, TurkeyQuicksort.findBeginning(array, erstes, letztes, comparer),
						array);	/*whlt als Vergleichselement:
						 			*das mittlere Element des Teilarrays fr Anzahl<8
						 			*den Median aus 3 Elementen des Teilarray fr Anzahl<41
						 			*den Pseudomedian aus 9 Elementen des Teilarrays fr Anzahl>40
								und legt das Vergleichselement an die erste Position des Teilrrays*/
			
			int iterL;
			
			int putL=iterL=erstes+1;
			int iterR=letztes;
			int putR=letztes;
			while(iterL<=iterR)
			{
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von links ein greres Element*/
					if(0==comparer.compare(iterL, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putL++, iterL, array);			/*den linken Rand geschoben*/
					iterL++;
				}
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von rechts ein greres Element*/
					if(0==comparer.compare(iterR, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putR--, iterL, array);			/*den rechten Rand geschoben*/
					iterR--;
				}
				
				if(iterL>iterR)	/*bricht ab, sobald der Iterator von links und der Iterator von 
								rechts sich kreuzen (Abbruchbedingung)*/
					break;
				
				swapper.swap(iterL, iterR, array);	/*tauscht das gerhe und das kleinere
													Element*/			
			}
			
			int min=Math.min(putL, iterL-putL); /*berechnet die Anzahl der gleichen Elemente am
												linken Rand, die verschoben werden mssen*/
			
			for(int i=erstes, h=iterL-min; min>0 ;min--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			min=Math.min(putR, iterR);	/*berechnet die Anzahl der gleichen Elemente am
										rechten Rand, die verschoben werden mssen*/
			
			for(int i=iterR, h=letztes+1-min;min>0;min--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			quicksort(array, erstes, erstes+iterL-putL, comparer);	/*auf dem Teilarray kleiner dem
																	Vergleichselement*/

			quicksort(array, letztes-putR+iterR, letztes, comparer);/*auf dem Teilarray grer dem
																	Vergleichselement*/
			
		}

	}

	@Override
	public void quicksort(int[] array, int erstes, int letztes,
			CompareIntInterface comparer) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
			SwapIntInterface swapper=new IntArrayTool();
			swapper.swap(erstes, TurkeyQuicksort.findBeginning(array, erstes, letztes, comparer),
						array);	/*whlt als Vergleichselement:
						 			*das mittlere Element des Teilarrays fr Anzahl<8
						 			*den Median aus 3 Elementen des Teilarray fr Anzahl<41
						 			*den Pseudomedian aus 9 Elementen des Teilarrays fr Anzahl>40
								und legt das Vergleichselement an die erste Position des Teilrrays*/
			
			int iterL;
			
			int putL=iterL=erstes+1;
			int iterR=letztes;
			int putR=letztes;
			while(iterL<=iterR)
			{
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von links ein greres Element*/
					if(0==comparer.compare(iterL, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putL++, iterL, array);			/*den linken Rand geschoben*/
					iterL++;
				}
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von rechts ein greres Element*/
					if(0==comparer.compare(iterR, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putR--, iterL, array);			/*den rechten Rand geschoben*/
					iterR--;
				}
				
				if(iterL>iterR)	/*bricht ab, sobald der Iterator von links und der Iterator von 
								rechts sich kreuzen (Abbruchbedingung)*/
					break;
				
				swapper.swap(iterL, iterR, array);	/*tauscht das gerhe und das kleinere
													Element*/			
			}
			
			int min=Math.min(putL, iterL-putL); /*berechnet die Anzahl der gleichen Elemente am
												linken Rand, die verschoben werden mssen*/
			
			for(int i=erstes, h=iterL-min; min>0 ;min--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			min=Math.min(putR, iterR);	/*berechnet die Anzahl der gleichen Elemente am
										rechten Rand, die verschoben werden mssen*/
			
			for(int i=iterR, h=letztes+1-min;min>0;min--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			quicksort(array, erstes, erstes+iterL-putL, comparer);	/*auf dem Teilarray kleiner dem
																	Vergleichselement*/

			quicksort(array, letztes-putR+iterR, letztes, comparer);/*auf dem Teilarray grer dem
																	Vergleichselement*/
			
		}

	}

	@Override
	public void quicksort(String[] array, int erstes, int letztes,
			CompareStringInterface comparer) {
		// TODO Auto-generated method stub
		
		if(letztes-erstes>0)
		{
			SwapStringInterface swapper=new SwapString();
			swapper.swap(erstes, TurkeyQuicksort.findBeginning(array, erstes, letztes, comparer),
						array);	/*whlt als Vergleichselement:
						 			*das mittlere Element des Teilarrays fr Anzahl<8
						 			*den Median aus 3 Elementen des Teilarray fr Anzahl<41
						 			*den Pseudomedian aus 9 Elementen des Teilarrays fr Anzahl>40
								und legt das Vergleichselement an die erste Position des Teilrrays*/
			
			int iterL;
			
			int putL=iterL=erstes+1;
			int iterR=letztes;
			int putR=letztes;
			while(iterL<=iterR)
			{
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von links ein greres Element*/
					if(0==comparer.compare(iterL, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putL++, iterL, array);			/*den linken Rand geschoben*/
					iterL++;
				}
				while(iterL<=iterR && 0>=comparer.compare(iterL, erstes, array))
				{								/*sucht von rechts ein greres Element*/
					if(0==comparer.compare(iterR, erstes, array))	/*gleiche Elemente werden an*/
						swapper.swap(putR--, iterL, array);			/*den rechten Rand geschoben*/
					iterR--;
				}
				
				if(iterL>iterR)	/*bricht ab, sobald der Iterator von links und der Iterator von 
								rechts sich kreuzen (Abbruchbedingung)*/
					break;
				
				swapper.swap(iterL, iterR, array);	/*tauscht das gerhe und das kleinere
													Element*/			
			}
			
			int min=Math.min(putL, iterL-putL); /*berechnet die Anzahl der gleichen Elemente am
												linken Rand, die verschoben werden mssen*/
			
			for(int i=erstes, h=iterL-min; min>0 ;min--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			min=Math.min(putR, iterR);	/*berechnet die Anzahl der gleichen Elemente am
										rechten Rand, die verschoben werden mssen*/
			
			for(int i=iterR, h=letztes+1-min;min>0;min--)	/*verschiebt die gleichen Elemente*/
				swapper.swap(i++, h++, array);				/*in die Mitte*/
			
			quicksort(array, erstes, erstes+iterL-putL, comparer);	/*auf dem Teilarray kleiner dem
																	Vergleichselement*/

			quicksort(array, letztes-putR+iterR, letztes, comparer);/*auf dem Teilarray grer dem
																	Vergleichselement*/
			
		}

	}

}
