/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package matrix.test;

/**
 *
 * @author Daniel
 */
public class StrassenTest {
     
    private static final int cutOff=64;
    
    public static void print(int[][] a){
        for (int i=0;i<a.length;i++){
            System.out.print("|");
            for (int j=0;j<a[i].length;j++) System.out.print(a[i][j]+" ");
            System.out.println("|");
        }
        System.out.println();
    }
    
    
    public static int[][] mulx(int[][] a, int[][] b){
        int[][] newMatrix=new int[a.length][b[0].length];
        for (int row=0;row<a.length;row++){
            for (int bcol=0;bcol<b[0].length;bcol++){
                for (int acol=0; acol<a[row].length; acol++) 
                    newMatrix[row][bcol]+=a[row][acol]*b[acol][bcol];
            }
        }
        return newMatrix;
    }
    
    private static int[][] subMatrix(int subSize, int[][] a, int i0, int i1){
        int[][] sub=new int[subSize][subSize];
        int offset1=(i0==0)?0:subSize;
        int offset2, length;
        if (i1==0) {offset2=0; length=(a[0].length<subSize)?a[0].length:subSize;}
        else{offset2=subSize; length=(a[0].length<=subSize)?0:a[0].length-subSize;}
        for (int i=0;i<subSize;i++)
            if ((i+offset1)<a.length&&length>0)  System.arraycopy(a[i+offset1], offset2, sub[i], 0, length);
        return sub;
    }
    
    private static int[][] subMatrix3(int[][] a, int i0, int i1){
        int[][] sub=new int[a.length/2][a.length/2];
        int offset1=(i0==0)?0:sub.length;
        int offset2=(i1==0)?0:sub.length;
        for (int i=0;0<sub.length;i++)
            System.arraycopy(a[i+offset1], offset2, sub[i], 0, sub.length);
        return sub;
    }
    
    public static int[][] mulr3(int[][] a, int[][] b){
        if (a.length==1&&b[0].length==1) return new int[][] {{a[0][0]*b[0][0]}};
        
        return null;
    }
    
    private static int[][] mulr(int[][] a, int[][] b){
        if (a.length==1&&b[0].length==1) 
            return new int[][] {{a[0][0]*b[0][0]}};
        int subSize=((int)(Math.pow(2.0, Math.ceil(Math.log(
                Math.max(b[0].length, Math.max(a.length, a[0].length)))
                /Math.log(2.0)))))/2;
        
        int[][] a11=subMatrix(subSize, a, 0, 0);
        int[][] a12=subMatrix(subSize, a, 0, 1);
        int[][] a21=subMatrix(subSize, a, 1, 0);
        int[][] a22=subMatrix(subSize, a, 1, 1);
        int[][] b11=subMatrix(subSize, b, 0, 0);
        int[][] b12=subMatrix(subSize, b, 0, 1);
        int[][] b21=subMatrix(subSize, b, 1, 0);
        int[][] b22=subMatrix(subSize, b, 1, 1);
        
        int[][] c11=plus(mulr(a11, b11), mulr(a12, b21));
        int[][] c12=plus(mulr(a11, b12), mulr(a12, b22));
        int[][] c21=plus(mulr(a21, b11), mulr(a22, b21));
        int[][] c22=plus(mulr(a21, b12), mulr(a22, b22));
        
        int[][] product=new int[a.length][b[0].length];
        int offset1=product[0].length<subSize?product[0].length:subSize;
        int offset2=product[0].length<subSize?0:product[0].length-subSize;
        int offset3=product.length<subSize?product.length:subSize;
        for (int i=0;i<offset3;i++){
            System.arraycopy(c11[i], 0, product[i], 0, offset1);
            if (offset2!=0) 
                System.arraycopy(c12[i], 0, product[i], subSize, offset2);
        }
        for (int i=subSize; i<product.length;i++){
            System.arraycopy(c21[i-subSize], 0, product[i], 0, offset1);
            if (offset2!=0) 
                System.arraycopy(c22[i-subSize], 0, product[i], subSize, offset2);
        }
        return product;
    }
    
    public static int[][] mulrAlt(int[][] a, int[][] b){
        if (a.length<cutOff) return mulx(a, b);
        
        int size=((int)(Math.pow(2.0, Math.ceil(Math.log(a.length)/Math.log(2.0)))))/2;
        int[][] a11=subMatrixAlt(size, a, 0, 0);
        int[][] a12=subMatrixAlt(size, a, 0, 1);
        int[][] a21=subMatrixAlt(size, a, 1, 0);
        int[][] a22=subMatrixAlt(size, a, 1, 1);
        int[][] b11=subMatrixAlt(size, b, 0, 0);
        int[][] b12=subMatrixAlt(size, b, 0, 1);
        int[][] b21=subMatrixAlt(size, b, 1, 0);
        int[][] b22=subMatrixAlt(size, b, 1, 1);
        
        int[][] c11=plus(mulrAlt(a11, b11), mulrAlt(a12, b21));
        int[][] c12=plus(mulrAlt(a11, b12), mulrAlt(a12, b22));
        int[][] c21=plus(mulrAlt(a21, b11), mulrAlt(a22, b21));
        int[][] c22=plus(mulrAlt(a21, b12), mulrAlt(a22, b22));
        
        int[][] product=new int[a.length][b[0].length];
        
        for (int i=0;i<size;i++){
            System.arraycopy(c11[i], 0, product[i], 0, c11[i].length);
            System.arraycopy(c12[i], 0, product[i], c11[i].length, product[i].length-c11[i].length);
        }
        for (int i=size; i<product.length;i++){
            System.arraycopy(c21[i-size], 0, product[i], 0, c21[0].length);
            System.arraycopy(c22[i-size], 0, product[i], c21[0].length, product[i].length-c21[0].length);
        }
        return product;
    }
        
    private static int[][] plus(int[][] a, int[][] b){
        int[][] sum=new int[a.length][a[0].length];
        for (int i=0; i<sum.length; i++){
            for (int j=0; j<sum[0].length; j++)
                sum[i][j]=a[i][j]+b[i][j];
        }
        return sum;
    }
    
    private static int[][] sub(int[][] a, int[][] b){
        int[][] difference=new int[a.length][a[0].length];
        for (int i=0; i<difference.length; i++){
            for (int j=0; j<difference.length; j++)
                difference[i][j]=a[i][j]-b[i][j];
        }
        return difference;
    }
    
    private static int[][] subMatrixAlt(int size, int[][] a, int i0, int i1) {
        int[][] sub=new int[size][size];
        int offset1=(i0==0)?0:size;
        int offset2, length;
        if (i1==0) {offset2=0; length=(a[0].length<size)?a[0].length:size;}
        else{offset2=size; length=(a[0].length<size)?a[0].length:a[0].length-size;}
        for (int i=0;i<size;i++)
            if ((i+offset1)<a.length)  System.arraycopy(a[i+offset1], offset2, sub[i], 0, length);
        return sub;
    }
    
    private static int[][] subMatrixS(int size, int[][] a, int i0, int i1){
        int[][] sub=new int[size][size];
        int offset1=(i0==0)?0:size;
        int offset2=(i1==0)?0:size;
        for (int i=0;i<size;i++)
            System.arraycopy(a[i+offset1], offset2, sub[i], 0, size);
        return sub;
    }
    
    public static int[][] strassenS(int [][] a, int[][] b){
        //wenn die Matrix Dimension klein genug ist wird der 
        //Standard-Algorithmus verwendet
        if (a.length<cutOff) return mulx(a, b);      
        int subSize=a.length/2;
        //Generierung der Submatrizen
        int[][] a11=subMatrixS(subSize, a, 0, 0), a12=subMatrixS(subSize, a, 0, 1);
        int[][] a21=subMatrixS(subSize, a, 1, 0);
        int[][] a22=subMatrixS(subSize, a, 1, 1);
        int[][] b11=subMatrixS(subSize, b, 0, 0);
        int[][] b12=subMatrixS(subSize, b, 0, 1);
        int[][] b21=subMatrixS(subSize, b, 1, 0);
        int[][] b22=subMatrixS(subSize, b, 1, 1);
        //Berechnung der Hilfsmatrizen
        int[][] m1=strassenS(plus(a11, a22), plus(b11, b22));
        int[][] m2=strassenS(plus(a21, a22), b11);
        int[][] m3=strassenS(a11, sub(b12, b22));
        int[][] m4=strassenS(a22, sub(b21, b11));
        int[][] m5=strassenS(plus(a11, a12), b22);      
        int[][] m6=strassenS(sub(a21, a11), plus(b11, b12));
        int[][] m7=strassenS(sub(a12, a22), plus(b21, b22));        
        //Berechnung des Produktes
        int[][] c11=plus(sub(plus(m1, m4), m5), m7);
        int[][] c12=plus(m3, m5);
        int[][] c21=plus(m2, m4);
        int[][] c22=plus(plus(sub(m1, m2), m3), m6);
        //Submatrizen zusammenführen
        int[][] product=new int[a.length][a.length];
        for (int i=0;i<subSize;i++){
            System.arraycopy(c11[i], 0, product[i], 0, subSize);
            System.arraycopy(c12[i], 0, product[i], subSize, subSize);
        }
        for (int i=0;i<subSize;i++){
            System.arraycopy(c21[i], 0, product[i+subSize], 0, subSize);
            System.arraycopy(c22[i], 0, product[i+subSize], subSize, subSize);
        }
        return product;
    }
    
    public static int[][] strassenT(int[][] a, int[][] b){
        int minSize=Math.min(Math.min(a.length, a[0].length),b[0].length);
        boolean quadratic=(a.length==a[0].length)&&(b.length==b[0].length)&&(a.length==b.length);
        
        if (quadratic&&minSize==Math.pow(2.0, Math.floor(Math.log(minSize)/Math.log(2.0)))) 
                return strassenS(a, b);
        
        if ((quadratic&&minSize<cutOff)||minSize-1<cutOff) return mulx(a, b);
        
        int size=(int)Math.pow(2.0, Math.floor(Math.log(minSize-1)/Math.log(2.0)));

        int[][] a11=new int[size][size], b11=new int[size][size];
        for (int i=0;i<size;i++){
            System.arraycopy(a[i], 0, a11[i], 0, size);
            System.arraycopy(b[i], 0, b11[i], 0, size);
        }        
        
        int[][] a12=new int[size][a[0].length-size]; 
        int[][] b12=new int[size][b[0].length-size];
        for (int i=0;i<size;i++){
            System.arraycopy(a[i], size, a12[i], 0, a[0].length-size);
            System.arraycopy(b[i], size, b12[i], 0, b[0].length-size);
        }
        
        int[][] a21=new int[a.length-size][size];
        int[][] b21=new int[b.length-size][size];
        for (int i=size;i<a.length;i++)
            System.arraycopy(a[i], 0, a21[i-size], 0, size);
        for (int i=size;i<b.length;i++)
            System.arraycopy(b[i], 0, b21[i-size], 0, size);
        
        int[][] a22=new int[a.length-size][a[0].length-size];
        int[][] b22=new int[b.length-size][b[0].length-size];
        for (int i=size;i<a.length;i++)
            System.arraycopy(a[i], size, a22[i-size], 0, a[0].length-size);
        for (int i=size;i<b.length;i++)
            System.arraycopy(b[i], size, b22[i-size], 0, b[0].length-size);
        
        int[][] c11=plus(strassenS(a11, b11), strassenT(a12, b21));
        int[][] c12=plus(strassenT(a11, b12), strassenT(a12, b22));
        int[][] c21=plus(strassenT(a21, b11), strassenT(a22, b21));
        int[][] c22=plus(strassenT(a21, b12), strassenT(a22, b22));
        
        int[][] product=new int[a.length][b[0].length];
        for (int i=0;i<size;i++){
            System.arraycopy(c11[i], 0, product[i], 0, size);
            System.arraycopy(c12[i], 0, product[i], size, b[0].length-size);
        }
        for (int i=size;i<a.length-size;i++){
            System.arraycopy(c21[i-size], 0, product[i], 0, size);
            System.arraycopy(c22[i-size], 0, product[i], size, b[0].length-size);
        }
        return product;
    }
    
    public static int[][] strassen(int [][] a, int[][] b){     
        if (Math.min(Math.min(a.length, a[0].length),b[0].length)<cutOff) 
            return mulx(a, b);
                
        int size=(int)(Math.pow(2.0, Math.ceil(Math.log(
                Math.max(b[0].length, Math.max(a.length, a[0].length)))
                /Math.log(2.0))));
        
        if ((a.length==a[0].length)&&(b.length==b[0].length)&&(a.length==size)) 
            return strassenS(a, b);
        
        int[][] aNew=new int[size][size];
        for (int i=0;i<a.length;i++)
            System.arraycopy(a[i], 0, aNew[i], 0, a[0].length);
        int[][] bNew=new int[size][size];
        for (int i=0;i<b.length;i++)
            System.arraycopy(b[i], 0, bNew[i], 0, b[0].length);
        
        int[][] c=strassenS(aNew, bNew);
        
        int[][] product=new int[a.length][b[0].length];
        for (int i=0;i<a.length;i++)
            System.arraycopy(c[i], 0, product[i], 0, b[0].length);
        return product;
    }
    
    public static int[][] strassen2(int [][] a, int[][] b){
        //wenn die Matrix Dimension klein genug ist wird der 
        //Standard-Algorithmus verwendet
        if (a.length<cutOff) return mulx(a, b);
        //Berechnug der Größe der Submatrix, so dass n=2^m ist
        int subSize=(int)(Math.pow(2.0, Math.ceil(Math.log(
                Math.max(b[0].length, Math.max(a.length, a[0].length)))
                /Math.log(2.0))))/2;
        //generieren der Submatrizen
        int[][] a11=subMatrix(subSize, a, 0, 0);
        int[][] a12=subMatrix(subSize, a, 0, 1);
        int[][] a21=subMatrix(subSize, a, 1, 0);
        int[][] a22=subMatrix(subSize, a, 1, 1);
        int[][] b11=subMatrix(subSize, b, 0, 0);
        int[][] b12=subMatrix(subSize, b, 0, 1);
        int[][] b21=subMatrix(subSize, b, 1, 0);
        int[][] b22=subMatrix(subSize, b, 1, 1);
        //Berechnung der Hilfsmatrizen
        int[][] m1=strassen2(plus(a11, a22), plus(b11, b22));
        int[][] m2=strassen2(plus(a21, a22), b11);
        int[][] m3=strassen2(a11, sub(b12, b22));
        int[][] m4=strassen2(a22, sub(b21, b11));
        int[][] m5=strassen2(plus(a11, a12), b22);      
        int[][] m6=strassen2(sub(a21, a11), plus(b11, b12));
        int[][] m7=strassen2(sub(a12, a22), plus(b21, b22));        
        //Berechnung der Ergebnis-Submatrizen
        int[][] c11=plus(sub(plus(m1, m4), m5), m7);
        int[][] c12=plus(m3, m5);
        int[][] c21=plus(m2, m4);
        int[][] c22=plus(plus(sub(m1, m2), m3), m6);
        //Zurücktrasferierung des Produktes auf die ursprüngliche Größe
        int[][] product=new int[a.length][b[0].length];
        int offset1=product[0].length<subSize?product[0].length:subSize;
        int offset2=product[0].length<subSize?0:product[0].length-subSize;
        int offset3=product.length<subSize?product.length:subSize;
        for (int i=0;i<offset3;i++){
            System.arraycopy(c11[i], 0, product[i], 0, offset1);
            if (offset2!=0) 
                System.arraycopy(c12[i], 0, product[i], subSize, offset2);
        }
        for (int i=subSize; i<product.length;i++){
            System.arraycopy(c21[i-subSize], 0, product[i], 0, offset1);
            if (offset2!=0) 
                System.arraycopy(c22[i-subSize], 0, product[i], subSize, offset2);
        }
        return product;
    }
    
    public static int[][] strassen_dep(int [][] a, int[][] b){
        if (a.length<cutOff) return mulx(a, b);
        
        int size=(int)(Math.pow(2.0, Math.ceil(Math.log(a.length)/Math.log(2.0))));
        int halfSize=size/2;
        int[][] aFillZero=new int[size][size];
        for (int i=0;i<a.length;i++)
            System.arraycopy(a[i], 0, aFillZero[i], 0, a[0].length);
        
        int[][] a11=subMatrix(size, a, 0, 0);
        int[][] a12=subMatrix(size, a, 0, 1);
        int[][] a21=subMatrix(size, a, 1, 0);
        int[][] a22=subMatrix(size, a, 1, 1);
        int[][] b11=subMatrix(size, b, 0, 0);
        int[][] b12=subMatrix(size, b, 0, 1);
        int[][] b21=subMatrix(size, b, 1, 0);
        int[][] b22=subMatrix(size, b, 1, 1);
        
        int[][] m1=strassen_dep(plus(a11, a22), plus(b11, b22));
        int[][] m2=strassen_dep(plus(a21, a22), b11);
        int[][] m3=strassen_dep(a11, sub(b12, b22));
        int[][] m4=strassen_dep(a22, sub(b21, b11));
        int[][] m5=strassen_dep(plus(a11, a12), b22);      
        int[][] m6=strassen_dep(sub(a21, a11), plus(b11, b12));
        int[][] m7=strassen_dep(sub(a12, a22), plus(b21, b22));        
        
        int[][] c11=plus(sub(plus(m1, m4), m5), m7);
        int[][] c12=plus(m3, m5);
        int[][] c21=plus(m2, m4);
        int[][] c22=plus(plus(sub(m1, m2), m3), m6);
        
        int[][] product=new int[a.length][a.length];
        
        for (int i=0;i<halfSize;i++){
            System.arraycopy(c11[i], 0, product[i], 0, c11[i].length);
            System.arraycopy(c12[i], 0, product[i], c11[i].length, product[i].length-c11[i].length);
        }
        for (int i=halfSize; i<product.length;i++){
            System.arraycopy(c21[i-halfSize], 0, product[i], 0, c21[0].length);
            System.arraycopy(c22[i-halfSize], 0, product[i], c21[0].length, product[i].length-c21[0].length);
        }
        return product;
    }
    
    
    private static int getSize(int[][] a, int[][] b){
        if (a[0].length!=b.length) return 0;
        return ((int)(Math.pow(2.0, Math.ceil(Math.log(
                Math.max(b[0].length, Math.max(a.length, a[0].length)))
                /Math.log(2.0)))));
    }
    
    private static int getSize2(int[][] a, int[][] b){
        if (a[0].length!=b.length) return 0;
        return ((int)(Math.pow(2.0, Math.ceil(Math.log(a.length)/Math.log(2.0)))));
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int[][] a={{0,1,0,1},
                   {1,0,1,0},
                   {0,1,0,1},
                   {1,0,1,0}};
        print(a);
        print(strassenT(a,a));
        /*int size=1025;
        int[][] a=new int[size][size], b=new int[size][size];
        mulx(a, b);
        strassenT(a, b);
        strassen(a, b);*/ 
        /*int[][] a={{1,2,3}};
        int[][] b={{1,1,1,1,1,1},{2,2,2,2,2,2},{3,3,3,3,3,3}};
        
        print(a);
        print(b);
        //System.out.println(getSize(a, b));
        
        print(mulr(a, b));
        //System.out.println(getSize2(a, b));
        */
        /*int[][] a1={{1,2,3},{1,2,3}}, b1={{1},{1},{1}};
        int[][] a2={{1,2},{3,4},{5,6}}, b2={{1,2},{1,2}};
        
        int[][] a4={{1,2,3,4},{0,1,0,1},{1,2,1,2},{1,1,1,1}}, 
                b4={{2,2,2,2},{1,1,1,1},{3,3,3,3},{1,1,1,1}};
        
        int[][] a5={{1,2,3,4,5},{0,1,0,1,0},{1,2,1,2,1},{1,1,1,1,1},{2,3,2,3,2}}, 
                b5={{2,2,2,2,2},{1,1,1,1,1},{3,3,3,3,3},{1,1,1,1,1},{1,2,1,2,1}};
        
        int[][] a8={{1,2,3,4,5,6,7,8},
                    {0,1,0,1,0,1,0,1},
                    {1,2,1,2,1,1,2,1},
                    {1,1,1,1,1,1,1,1},
                    {2,3,2,3,2,3,2,3},
                    {1,1,1,1,1,1,1,1},
                    {1,0,1,0,1,0,1,0},
                    {2,4,6,8,1,3,5,7}}, 
                b8={{2,2,2,2,2,2,2,2},
                    {1,1,1,1,1,1,1,1},
                    {3,3,3,3,3,3,3,3},
                    {1,1,1,1,1,1,1,1},
                    {1,2,1,2,1,2,1,2},
                    {4,4,4,4,4,4,4,4},
                    {0,0,0,0,0,0,0,0},
                    {5,5,5,5,5,5,5,5}};
        
        int[][] a16={{1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8},
                     {0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1},
                     {1,2,1,2,1,1,2,1,1,2,1,2,1,1,2,1},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0},
                     {2,4,6,8,1,3,5,7,2,4,6,8,1,3,5,7},
                     {1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8},
                     {0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1},
                     {1,2,1,2,1,1,2,1,1,2,1,2,1,1,2,1},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0},
                     {2,4,6,8,1,3,5,7,2,4,6,8,1,3,5,7}}, 
                b16={{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2},
                     {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                     {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                     {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                     {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
                     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                     {1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2},
                     {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                     {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                     {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}};
        
        int[][] a64=new int[32][32], b64=new int[32][32];
        
        mulx(a64, b64);
        //strassen2(a64, b64);
        mulr(a64, b64);
        //strassen(a64, b64);
        //int[][] a=new int[][]{{1},{2},{3}}, b=new int[][]{{1, 2, 3}};
        /*int[][] a=new int[][]{{1,2,3},{1,2,3},{1,2,3},{1,2,3},{1,2,3}}, b=new int[][]{{1},{2},{3}};
        print(mulx(a, b));
        print(mulr(a, b));
        print(strassen2(a, b));
        print(strassen(a, b));*/
    }

}
